package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TQtdevinfoValueExample {
    /**
     * t_qtdevinfo_value
     */
    protected String orderByClause;

    /**
     * t_qtdevinfo_value
     */
    protected boolean distinct;

    /**
     * t_qtdevinfo_value
     */
    protected List<Criteria> oredCriteria;

    public TQtdevinfoValueExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_qtdevinfo_value 2019-03-26
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeIsNull() {
            addCriterion("v_dev_code is null");
            return (Criteria) this;
        }

        public Criteria andVDevCodeIsNotNull() {
            addCriterion("v_dev_code is not null");
            return (Criteria) this;
        }

        public Criteria andVDevCodeEqualTo(String value) {
            addCriterion("v_dev_code =", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeNotEqualTo(String value) {
            addCriterion("v_dev_code <>", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeGreaterThan(String value) {
            addCriterion("v_dev_code >", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_dev_code >=", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeLessThan(String value) {
            addCriterion("v_dev_code <", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeLessThanOrEqualTo(String value) {
            addCriterion("v_dev_code <=", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeLike(String value) {
            addCriterion("v_dev_code like", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeNotLike(String value) {
            addCriterion("v_dev_code not like", value, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeIn(List<String> values) {
            addCriterion("v_dev_code in", values, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeNotIn(List<String> values) {
            addCriterion("v_dev_code not in", values, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeBetween(String value1, String value2) {
            addCriterion("v_dev_code between", value1, value2, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVDevCodeNotBetween(String value1, String value2) {
            addCriterion("v_dev_code not between", value1, value2, "vDevCode");
            return (Criteria) this;
        }

        public Criteria andVValueTimeIsNull() {
            addCriterion("v_value_time is null");
            return (Criteria) this;
        }

        public Criteria andVValueTimeIsNotNull() {
            addCriterion("v_value_time is not null");
            return (Criteria) this;
        }

        public Criteria andVValueTimeEqualTo(Date value) {
            addCriterion("v_value_time =", value, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeNotEqualTo(Date value) {
            addCriterion("v_value_time <>", value, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeGreaterThan(Date value) {
            addCriterion("v_value_time >", value, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("v_value_time >=", value, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeLessThan(Date value) {
            addCriterion("v_value_time <", value, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeLessThanOrEqualTo(Date value) {
            addCriterion("v_value_time <=", value, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeIn(List<Date> values) {
            addCriterion("v_value_time in", values, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeNotIn(List<Date> values) {
            addCriterion("v_value_time not in", values, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeBetween(Date value1, Date value2) {
            addCriterion("v_value_time between", value1, value2, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andVValueTimeNotBetween(Date value1, Date value2) {
            addCriterion("v_value_time not between", value1, value2, "vValueTime");
            return (Criteria) this;
        }

        public Criteria andCpoAvgIsNull() {
            addCriterion("cpo_avg is null");
            return (Criteria) this;
        }

        public Criteria andCpoAvgIsNotNull() {
            addCriterion("cpo_avg is not null");
            return (Criteria) this;
        }

        public Criteria andCpoAvgEqualTo(BigDecimal value) {
            addCriterion("cpo_avg =", value, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgNotEqualTo(BigDecimal value) {
            addCriterion("cpo_avg <>", value, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgGreaterThan(BigDecimal value) {
            addCriterion("cpo_avg >", value, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cpo_avg >=", value, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgLessThan(BigDecimal value) {
            addCriterion("cpo_avg <", value, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cpo_avg <=", value, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgIn(List<BigDecimal> values) {
            addCriterion("cpo_avg in", values, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgNotIn(List<BigDecimal> values) {
            addCriterion("cpo_avg not in", values, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cpo_avg between", value1, value2, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andCpoAvgNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cpo_avg not between", value1, value2, "cpoAvg");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeIsNull() {
            addCriterion("v_dev_kind_code is null");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeIsNotNull() {
            addCriterion("v_dev_kind_code is not null");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeEqualTo(String value) {
            addCriterion("v_dev_kind_code =", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotEqualTo(String value) {
            addCriterion("v_dev_kind_code <>", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeGreaterThan(String value) {
            addCriterion("v_dev_kind_code >", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_dev_kind_code >=", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeLessThan(String value) {
            addCriterion("v_dev_kind_code <", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeLessThanOrEqualTo(String value) {
            addCriterion("v_dev_kind_code <=", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeLike(String value) {
            addCriterion("v_dev_kind_code like", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotLike(String value) {
            addCriterion("v_dev_kind_code not like", value, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeIn(List<String> values) {
            addCriterion("v_dev_kind_code in", values, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotIn(List<String> values) {
            addCriterion("v_dev_kind_code not in", values, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeBetween(String value1, String value2) {
            addCriterion("v_dev_kind_code between", value1, value2, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andVDevKindCodeNotBetween(String value1, String value2) {
            addCriterion("v_dev_kind_code not between", value1, value2, "vDevKindCode");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }
    }

    /**
     * t_qtdevinfo_value
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_qtdevinfo_value 2019-03-26
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}